from sys import argv, stdin, exit
from re import match

assert len(argv)==4, "correct usage: python3 %s input our_output contestants_output" % argv[0]

our_output_tokens = open(argv[2],'r').read().split()

try:
    try:
        their_output_tokens = open(argv[3],'r').read().split()
    except:
        assert False, "Failed to parse the submission (binary file?)"

    assert len(our_output_tokens) == len(their_output_tokens), "Incorrect number of answers in the contestants' output file."
    for i, token in enumerate(their_output_tokens):
        assert match(r'^[0-9]+:[RL]*$', token), "Answer to test case #{} does not have the form (number):(string of Ls and Rs).".format(i+1)

    fin = open(argv[1],'r')
    TESTS = int( fin.readline() )
    for test in range(TESTS):
        fin.readline()
        N, X, K = [ int(x) for x in fin.readline().split() ]
        X -= 1
        A = [X] + [ int(x)-1 for x in fin.readline().split() ]

        our_len, our_sol = our_output_tokens[test].split(':')
        their_len, their_sol = their_output_tokens[test].split(':')
        assert int(our_len) == int(their_len), "Answer to test case #{} does not have the optimal length.".format(test+1)
        assert int(their_len) == len(their_sol), "The number in test case #{} does not match the length of the string of Ls and Rs.".format(test+1)

        waiting = 0
        where = X
        while (waiting < len(A)) and A[waiting] == where: waiting += 1
        for ferry_type in their_sol:
            row = where % N
            column = int( (ferry_type == 'R') ^ (where < N) )
            where = 2*row + column
            while (waiting < len(A)) and A[waiting] == where: waiting += 1

        assert waiting == len(A), "The string of Ls and Rs in test case #{} does not produce the required sequence of observations.".format(test+1)

except Exception as error_message:
    # print(error_message)
    print('Wrong answer')
    exit(1)

print("OK")
